/**
 *
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.apache.activemq.karaf.audit;

import org.apache.activemq.broker.util.AuditLog;
import org.apache.activemq.broker.util.AuditLogEntry;
import org.osgi.service.event.Event;
import org.osgi.service.event.EventAdmin;

import java.util.Dictionary;
import java.util.Hashtable;

public class EventAdminAuditLog implements AuditLog {

    private EventAdmin eventAdmin;

    @Override
    public void log(AuditLogEntry entry) {
        try {
            eventAdmin.sendEvent(createEvent(entry));
        } catch (Throwable t) {
            t.printStackTrace();
        }
    }

    private Event createEvent(AuditLogEntry entry) {
        Dictionary dictionary = new Hashtable();
        dictionary.put("entry", entry);
        return new Event(Activator.EVENT_TOPIC, dictionary);
    }

    public EventAdmin getEventAdmin() {
        return eventAdmin;
    }

    public void setEventAdmin(EventAdmin eventAdmin) {
        this.eventAdmin = eventAdmin;
    }
}
